<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTroubleConditionWithDates ArrayType
 * @subpackage Arrays
 */
class ArrayOfTroubleConditionWithDates extends AbstractStructArrayBase
{
    /**
     * The TroubleConditionWithDates
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\TroubleConditionWithDates[]
     */
    public $TroubleConditionWithDates;
    /**
     * Constructor method for ArrayOfTroubleConditionWithDates
     * @uses ArrayOfTroubleConditionWithDates::setTroubleConditionWithDates()
     * @param \CustomerManagement\StructType\TroubleConditionWithDates[] $troubleConditionWithDates
     */
    public function __construct(array $troubleConditionWithDates = array())
    {
        $this
            ->setTroubleConditionWithDates($troubleConditionWithDates);
    }
    /**
     * Get TroubleConditionWithDates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\TroubleConditionWithDates[]|null
     */
    public function getTroubleConditionWithDates()
    {
        return isset($this->TroubleConditionWithDates) ? $this->TroubleConditionWithDates : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTroubleConditionWithDates method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTroubleConditionWithDates method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTroubleConditionWithDatesForArrayConstraintsFromSetTroubleConditionWithDates(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTroubleConditionWithDatesTroubleConditionWithDatesItem) {
            // validation for constraint: itemType
            if (!$arrayOfTroubleConditionWithDatesTroubleConditionWithDatesItem instanceof \CustomerManagement\StructType\TroubleConditionWithDates) {
                $invalidValues[] = is_object($arrayOfTroubleConditionWithDatesTroubleConditionWithDatesItem) ? get_class($arrayOfTroubleConditionWithDatesTroubleConditionWithDatesItem) : sprintf('%s(%s)', gettype($arrayOfTroubleConditionWithDatesTroubleConditionWithDatesItem), var_export($arrayOfTroubleConditionWithDatesTroubleConditionWithDatesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TroubleConditionWithDates property can only contain items of type \CustomerManagement\StructType\TroubleConditionWithDates, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TroubleConditionWithDates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\TroubleConditionWithDates[] $troubleConditionWithDates
     * @return \CustomerManagement\ArrayType\ArrayOfTroubleConditionWithDates
     */
    public function setTroubleConditionWithDates(array $troubleConditionWithDates = array())
    {
        // validation for constraint: array
        if ('' !== ($troubleConditionWithDatesArrayErrorMessage = self::validateTroubleConditionWithDatesForArrayConstraintsFromSetTroubleConditionWithDates($troubleConditionWithDates))) {
            throw new \InvalidArgumentException($troubleConditionWithDatesArrayErrorMessage, __LINE__);
        }
        if (is_null($troubleConditionWithDates) || (is_array($troubleConditionWithDates) && empty($troubleConditionWithDates))) {
            unset($this->TroubleConditionWithDates);
        } else {
            $this->TroubleConditionWithDates = $troubleConditionWithDates;
        }
        return $this;
    }
    /**
     * Add item to TroubleConditionWithDates value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\TroubleConditionWithDates $item
     * @return \CustomerManagement\ArrayType\ArrayOfTroubleConditionWithDates
     */
    public function addToTroubleConditionWithDates(\CustomerManagement\StructType\TroubleConditionWithDates $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\TroubleConditionWithDates) {
            throw new \InvalidArgumentException(sprintf('The TroubleConditionWithDates property can only contain items of type \CustomerManagement\StructType\TroubleConditionWithDates, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TroubleConditionWithDates[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\TroubleConditionWithDates|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\TroubleConditionWithDates|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\TroubleConditionWithDates|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\TroubleConditionWithDates|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\TroubleConditionWithDates|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TroubleConditionWithDates
     */
    public function getAttributeName()
    {
        return 'TroubleConditionWithDates';
    }
}
